/*
 * Jalview - A Sequence Alignment Editor and Viewer (Version 2.8.2)
 * Copyright (C) 2014 The Jalview Authors
 * 
 * This file is part of Jalview.
 * 
 * Jalview is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *  
 * Jalview is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty 
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE.  See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jalview.  If not, see <http://www.gnu.org/licenses/>.
 * The Jalview Authors are detailed in the 'AUTHORS' file.
 */
package jalview.ws.seqfetcher;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;

import jalview.datamodel.DBRefSource;
import jalview.ws.DBRefFetcher;
import jalview.ws.SequenceFetcher;
import jalview.ws.dbsources.das.api.jalviewSourceI;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 * @author jimp
 *
 */
public class DbRefFetcherTest
{

  /**
   * @throws java.lang.Exception
   */
  @BeforeClass
  public static void setUpBeforeClass() throws Exception
  {
  }

  /**
   * @throws java.lang.Exception
   */
  @AfterClass
  public static void tearDownAfterClass() throws Exception
  {
  }

  @Test
  public void testStandardProtDbs()
  {
    String[] defdb = DBRefSource.PROTEINDBS;
  List<DbSourceProxy> srces = new ArrayList<DbSourceProxy>();
  for (String ddb : defdb)
  {
    SequenceFetcher sfetcher= new SequenceFetcher();
    List<DbSourceProxy> srcesfordb = sfetcher.getSourceProxy(ddb);
    
    if (srcesfordb != null)
    {
      srces.addAll(srcesfordb);
    }
  }
  DbSourceProxy uniprot=null;
  int i=0;
  // append the selected sequence sources to the default dbs
  for (DbSourceProxy s:srces)
  {
    if (s.getDbSource().equalsIgnoreCase(DBRefSource.UNIPROT))
    {
      i++;
    }
    
    if (s instanceof jalview.ws.dbsources.Uniprot)
    {
      uniprot = s;
      break;
    }
  }
          
  assertTrue("Failed to find Uniprot source as first source amongst "+srces.size()+" sources (source was at position "+i+")", uniprot!=null && i<2);
  }

}
